diff -pruN 7.1.2+dfsg-2/ACE-INSTALL.html 7.1.3+dfsg-1/ACE-INSTALL.html
--- 7.1.2+dfsg-2/ACE-INSTALL.html	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ACE-INSTALL.html	2024-01-16 10:27:08.000000000 +0000
@@ -77,7 +77,7 @@ report process</a>.<p>
   <li><a href="#eclipse">Working with ACE in Eclipse</a></li>
   <li><a href="#advanced">Advanced Topics</a></li>
   <li><a href="#power">Building from git</a></li>
-</li></ul>
+</ul>
 
 
 <p></p><hr><p>
@@ -329,7 +329,7 @@ per-platform configuration method:</p>
       source tree.  The ACE recursive Makefile scheme needs this information.
       There are several ways to set the ACE_ROOT variable.  For example:
       <blockquote>
-      TSCH/CSH:
+      TCSH/CSH:
       <code>setenv ACE_ROOT /home/cs/faculty/schmidt/ACE_wrappers</code>
       </blockquote>
       <blockquote>
@@ -427,6 +427,9 @@ INSTALL_PREFIX = /usr/local
   </li>
   <li>If you've set the INSTALL_PREFIX before building, now run
 <blockquote><code>% make install</code></blockquote>
+    <p>An alternative to directly running <code>make install</make> is to use <code>$ACE_ROOT/bin/install_proj.sh</code>
+       which will only install projects that are built (instead of trying to build each one during <code>make install</code>).
+    </p>
   </li>
   <li>If you need to regenerate the <code>ace/Svc_Conf_y.cpp</code> file,
       you'll need to
@@ -2469,7 +2472,7 @@ perl bin/mwc.pl  -type vc71 -relative AC
 If you use the GNU GCC g++ compiler please note the following:
 
 <ul>
-  </p></li><li>ACE/TAO needs g++ 4.8 or better. Older versions are not usable anymore<p>
+  </p><li>ACE/TAO needs g++ 4.8 or better. Older versions are not usable anymore<p>
 
   </p></li><li>Make sure to update your gcc <code>config.status</code>
       file.  This file is produced when installing gcc; it specifies
diff -pruN 7.1.2+dfsg-2/ChangeLogs/ACE-7_1_3 7.1.3+dfsg-1/ChangeLogs/ACE-7_1_3
--- 7.1.2+dfsg-2/ChangeLogs/ACE-7_1_3	1970-01-01 00:00:00.000000000 +0000
+++ 7.1.3+dfsg-1/ChangeLogs/ACE-7_1_3	2024-01-16 10:27:08.000000000 +0000
@@ -0,0 +1,154 @@
+commit 06c65e4ec63d867b08b28524e65d404397c15d98
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Mon Jan 15 11:07:27 2024 +0100
+
+    List changes
+    
+        * ACE/NEWS:
+
+commit 56d5db9cd27ab6fb7aa88809f097daf94f8ef232
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Mon Jan 15 09:44:35 2024 +0100
+
+    Some modernization, use default, nullptr, const
+    
+        * ACE/ace/Barrier.cpp:
+        * ACE/ace/Future.cpp:
+        * ACE/ace/Future.h:
+        * ACE/ace/Future_Set.cpp:
+
+commit 0af46b720336d28f2b248d781d98f6a5ddf22158
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Sun Jan 14 13:03:11 2024 +0100
+
+    Add include for std::atomic
+    
+        * ACE/ace/Future.h:
+
+commit 6695073ad566bbcb5a4e8dd186308dd7e2911af3
+Merge: b94f1dc4f62 8c49e7b9d4c
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Sun Jan 14 13:01:17 2024 +0100
+
+    Merge branch 'master' into #2163-Race-condition-in-ACE_Future-double-checked-locking-pattern-code
+
+commit 4689fd055bff2c4280c6f0b8d81856b7e0bba666
+Merge: 4939d6b7232 7efcd5faa4d
+Author: Steve Huston <shuston@riverace.com>
+Date:   Fri Jan 12 16:18:47 2024 -0500
+
+    Merge branch 'master' into barrier_concurrency_fail
+
+commit b94f1dc4f622111ede7d06f0af70d39ff35056d7
+Author: Frank Hilliger <frank.hilliger@cs-sol.de>
+Date:   Wed Jan 10 11:31:12 2024 +0100
+
+    Fixed failed quality gates: C-style pointer casting
+
+commit 8ff73f4b883da21c5de3c53a0d9ef943e3757edd
+Author: Frank Hilliger <frank.hilliger@cs-sol.de>
+Date:   Wed Jan 10 08:38:47 2024 +0100
+
+    fixed findings of trailing_whitespaces check
+
+commit 13cafcfb76ed29d6687b5c8a7211e40dd142e944
+Author: Frank Hilliger <frank.hilliger@cs-sol.de>
+Date:   Tue Jan 9 18:08:47 2024 +0100
+
+    #2179: Fixed a race condition caused by the double checked locking pattern
+    - test case
+
+commit 30ab3c0586b7413490e98f181f4db0528c3f2119
+Author: nfrmtkr <frank.hilliger@cs-sol.de>
+Date:   Mon Jan 8 10:03:39 2024 +0100
+
+    Update Future.h
+    
+    Fixed a race condition caused by the double checked locking pattern by using an std::atomic that ensures correct and deterministic create and assignment logic.
+
+commit 58ea863f3a2e50b6a3045b59c7f1f060a8b7b5ae
+Merge: 587a7279b17 4df4192f41c
+Author: Justin Wilson <wilsonj@unityfoundation.io>
+Date:   Wed Dec 13 13:17:38 2023 -0600
+
+    Merge pull request #2171 from mitza-oci/install_proj
+    
+    Added a script install_proj.sh that can be used to run make install
+
+commit ee67b0516f51c3d722989e4b0e735dc1ae5596c6
+Author: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Date:   Wed Dec 13 14:15:40 2023 +0000
+
+    Sync debian/* files for ACE
+    
+    Signed-off-by: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+
+commit 4df4192f41c078099fddbbad68d212263137184f
+Author: Adam Mitz <mitza@objectcomputing.com>
+Date:   Fri Dec 8 12:18:25 2023 -0600
+
+    Added a script install_proj.sh that can be used to run make install
+
+commit 4939d6b723293824d970788a7726b222cdf8ca2b
+Author: Steve Huston <shuston@riverace.com>
+Date:   Fri Dec 1 22:04:44 2023 +0000
+
+    Change to C++ std::atomic
+
+commit 7e06ab1addf4df12d774fbb1a4fdf44b1d03ae39
+Author: Steve Huston <shuston@riverace.com>
+Date:   Fri Dec 1 17:59:11 2023 +0000
+
+    Change running_count_ to atomic to ensure accurate values across cores/CPUs.
+
+commit 160a687e5c78f0d83099c068e3cd051af7e25824
+Author: Marcin Cieślak <saper@saper.info>
+Date:   Sat Nov 25 03:06:02 2023 +0100
+
+    Build on FreeBSD 15.0
+    
+    ACE builds now with __FreeBSD_version 1500001
+
+commit f2bfbf8ce64ec3d34aa9ad369f9515be3b33ae59
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Wed Nov 22 11:16:44 2023 +0100
+
+    Identation change
+    
+        * ACE/ace/Future.cpp:
+
+commit c80d23d1123788cc4497376fb2a26b6dffb48d7c
+Merge: bd35628db2f 527ba7711f6
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Thu Nov 9 09:07:04 2023 +0100
+
+    Merge branch 'master' into jwi-nonconstcmsgspace
+
+commit bd35628db2ff60209d947222f4c1adaac412a841
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Thu Nov 9 09:05:58 2023 +0100
+
+    Add support for a non const CMSG_SPACE macro, some code is disabled at that moment
+    
+        * ACE/ace/SOCK_Dgram.cpp:
+        * ACE/ace/config-qnx.h:
+
+commit 1b2a86a2057f96fff3d72e8d2269d6b68c3a8da5
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Mon Oct 30 08:23:58 2023 +0100
+
+    Next release
+    
+        * ACE/bin/copy-local-script.sh:
+
+commit c9c19d844a1ca78ab287023c48ffa2e740c8bfc2
+Author: Johnny Willemsen <jwillemsen@remedy.nl>
+Date:   Mon Oct 30 08:22:34 2023 +0100
+
+    Make x.1.2 publicly available
+    
+        * ACE/NEWS:
+        * ACE/bin/diff-builds-and-group-fixed-tests-only.sh:
+        * ACE/docs/Download.html:
+        * ACE/etc/index.html:
+        * TAO/NEWS:
diff -pruN 7.1.2+dfsg-2/MPC/.github/workflows/windows.yml 7.1.3+dfsg-1/MPC/.github/workflows/windows.yml
--- 7.1.2+dfsg-2/MPC/.github/workflows/windows.yml	2023-10-30 06:58:05.000000000 +0000
+++ 7.1.3+dfsg-1/MPC/.github/workflows/windows.yml	2024-01-16 10:27:09.000000000 +0000
@@ -83,7 +83,7 @@ jobs:
     - name: Install vcpkg
       uses: lukka/run-vcpkg@v11
       with:
-        vcpkgGitCommitId: 5b1214315250939257ef5d62ecdcbca18cf4fb1c
+        vcpkgGitCommitId: c8696863d371ab7f46e213d8f5ca923c4aef2a00
         runVcpkgInstall: true
     - name: create $ACE_ROOT/ace/config.h
       run: |
diff -pruN 7.1.2+dfsg-2/MPC/config/ndds_ts_defaults.mpb 7.1.3+dfsg-1/MPC/config/ndds_ts_defaults.mpb
--- 7.1.2+dfsg-2/MPC/config/ndds_ts_defaults.mpb	2023-10-30 06:58:05.000000000 +0000
+++ 7.1.3+dfsg-1/MPC/config/ndds_ts_defaults.mpb	2024-01-16 10:27:09.000000000 +0000
@@ -2,7 +2,7 @@
 project {
   Define_Custom(NDDSTypeSupport) {
     command               = <%quote%>$(NDDSSCRIPTDIR)/rtiddsgen<%quote%>
-    commandflags          = -language C++ -replace -namespace $(PLATFORM_NDDS_FLAGS)
+    commandflags          = -replace -namespace $(PLATFORM_NDDS_FLAGS)
 
     dependent             = $(NDDSSCRIPTDIR)/rtiddsgen<%bat%>
 
diff -pruN 7.1.2+dfsg-2/NEWS 7.1.3+dfsg-1/NEWS
--- 7.1.2+dfsg-2/NEWS	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/NEWS	2024-01-16 10:27:08.000000000 +0000
@@ -1,3 +1,13 @@
+USER VISIBLE CHANGES BETWEEN ACE-7.1.2 and ACE-7.1.3
+====================================================
+
+. Fixed possible race conditions in extreme use case
+  in the barriar and future implementations
+
+. Improve support for QNX 7.1 and FreeBSD
+
+. Integrated debian packaging changes
+
 USER VISIBLE CHANGES BETWEEN ACE-7.1.1 and ACE-7.1.2
 ====================================================
 
diff -pruN 7.1.2+dfsg-2/PROBLEM-REPORT-FORM 7.1.3+dfsg-1/PROBLEM-REPORT-FORM
--- 7.1.2+dfsg-2/PROBLEM-REPORT-FORM	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/PROBLEM-REPORT-FORM	2024-01-16 10:27:08.000000000 +0000
@@ -25,7 +25,7 @@ include an entire platform-specific conf
 
 8<----------8<----------8<----------8<----------8<----------8<----------8<----
 
-    ACE VERSION: 7.1.2
+    ACE VERSION: 7.1.3
 
     HOST MACHINE and OPERATING SYSTEM:
         If on Windows based OS's, which version of WINSOCK do you
diff -pruN 7.1.2+dfsg-2/VERSION.txt 7.1.3+dfsg-1/VERSION.txt
--- 7.1.2+dfsg-2/VERSION.txt	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/VERSION.txt	2024-01-16 10:27:08.000000000 +0000
@@ -1,4 +1,4 @@
-This is ACE version 7.1.2, released Mon Oct 30 07:57:01 CET 2023
+This is ACE version 7.1.3, released Tue Jan 16 11:25:51 CET 2024
 
 If you have any problems with or questions about ACE, please open
 a issue or discussion on the ACE_TAO github project at
diff -pruN 7.1.2+dfsg-2/ace/Barrier.cpp 7.1.3+dfsg-1/ace/Barrier.cpp
--- 7.1.2+dfsg-2/ace/Barrier.cpp	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Barrier.cpp	2024-01-16 10:27:08.000000000 +0000
@@ -78,11 +78,10 @@ ACE_Barrier::wait ()
   ACE_TRACE ("ACE_Barrier::wait");
   ACE_GUARD_RETURN (ACE_Thread_Mutex, ace_mon, this->lock_, -1);
 
-  ACE_Sub_Barrier *sbp =
-    this->sub_barrier_[this->current_generation_];
+  ACE_Sub_Barrier *sbp = this->sub_barrier_[this->current_generation_];
 
   // Check for shutdown...
-  if (sbp == 0)
+  if (sbp == nullptr)
     {
       errno = ESHUTDOWN;
       return -1;
@@ -127,19 +126,18 @@ ACE_Barrier::shutdown ()
   ACE_TRACE ("ACE_Barrier::shutdown");
   ACE_GUARD_RETURN (ACE_Thread_Mutex, ace_mon, this->lock_, -1);
 
-  ACE_Sub_Barrier *sbp =
-    this->sub_barrier_[this->current_generation_];
+  ACE_Sub_Barrier *sbp = this->sub_barrier_[this->current_generation_];
 
   // Check for shutdown...
-  if (sbp == 0)
+  if (sbp == nullptr)
     {
       errno = ESHUTDOWN;
       return -1;
     }
 
   // Flag the shutdown
-  this->sub_barrier_[0] = 0;
-  this->sub_barrier_[1] = 0;
+  this->sub_barrier_[0] = nullptr;
+  this->sub_barrier_[1] = nullptr;
   // Tell all the threads waiting on the barrier to continue on their way.
   sbp->running_threads_ = this->count_;
   sbp->barrier_finished_.broadcast ();
diff -pruN 7.1.2+dfsg-2/ace/Barrier.h 7.1.3+dfsg-1/ace/Barrier.h
--- 7.1.2+dfsg-2/ace/Barrier.h	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Barrier.h	2024-01-16 10:27:08.000000000 +0000
@@ -45,6 +45,7 @@ ACE_END_VERSIONED_NAMESPACE_DECL
 
 #else /* ACE_HAS_THREADS */
 
+#include <atomic>
 #include "ace/Condition_Thread_Mutex.h"
 
 ACE_BEGIN_VERSIONED_NAMESPACE_DECL
@@ -63,7 +64,7 @@ struct ACE_Export ACE_Sub_Barrier
   ACE_Condition_Thread_Mutex barrier_finished_;
 
   /// Number of threads that are still running.
-  int running_threads_;
+  std::atomic<int> running_threads_;
 
   /// Dump the state of an object.
   void dump () const;
diff -pruN 7.1.2+dfsg-2/ace/Future.cpp 7.1.3+dfsg-1/ace/Future.cpp
--- 7.1.2+dfsg-2/ace/Future.cpp	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Future.cpp	2024-01-16 10:27:08.000000000 +0000
@@ -20,31 +20,11 @@ ACE_ALLOC_HOOK_DEFINE_Tc(ACE_Future_Rep)
 ACE_ALLOC_HOOK_DEFINE_Tc(ACE_Future)
 
 template <class T>
-ACE_Future_Holder<T>::ACE_Future_Holder ()
-{
-}
-
-template <class T>
 ACE_Future_Holder<T>::ACE_Future_Holder (const ACE_Future<T> &item)
   : item_ (item)
 {
 }
 
-template <class T>
-ACE_Future_Holder<T>::~ACE_Future_Holder ()
-{
-}
-
-template <class T>
-ACE_Future_Observer<T>::ACE_Future_Observer ()
-{
-}
-
-template <class T>
-ACE_Future_Observer<T>::~ACE_Future_Observer ()
-{
-}
-
 // Dump the state of an object.
 
 template <class T> void
@@ -74,10 +54,10 @@ ACE_Future_Rep<T>::dump () const
 template <class T> ACE_Future_Rep<T> *
 ACE_Future_Rep<T>::internal_create ()
 {
-  ACE_Future_Rep<T> *temp = 0;
+  ACE_Future_Rep<T> *temp {};
   ACE_NEW_RETURN (temp,
                   ACE_Future_Rep<T> (),
-                  0);
+                  nullptr);
   return temp;
 }
 
@@ -95,9 +75,9 @@ ACE_Future_Rep<T>::create ()
 template <class T> ACE_Future_Rep<T> *
 ACE_Future_Rep<T>::attach (ACE_Future_Rep<T>*& rep)
 {
-  ACE_ASSERT (rep != 0);
+  ACE_ASSERT (rep != nullptr);
   // Use value_ready_mutex_ for both condition and ref count management
-  ACE_GUARD_RETURN (ACE_SYNCH_RECURSIVE_MUTEX, r_mon, rep->value_ready_mutex_, 0);
+  ACE_GUARD_RETURN (ACE_SYNCH_RECURSIVE_MUTEX, r_mon, rep->value_ready_mutex_, nullptr);
   ++rep->ref_count_;
   return rep;
 }
@@ -105,7 +85,7 @@ ACE_Future_Rep<T>::attach (ACE_Future_Re
 template <class T> void
 ACE_Future_Rep<T>::detach (ACE_Future_Rep<T>*& rep)
 {
-  ACE_ASSERT (rep != 0);
+  ACE_ASSERT (rep != nullptr);
   // Use value_ready_mutex_ for both condition and ref count management
   ACE_GUARD (ACE_SYNCH_RECURSIVE_MUTEX, r_mon, rep->value_ready_mutex_);
 
@@ -122,8 +102,8 @@ ACE_Future_Rep<T>::detach (ACE_Future_Re
 template <class T> void
 ACE_Future_Rep<T>::assign (ACE_Future_Rep<T>*& rep, ACE_Future_Rep<T>* new_rep)
 {
-  ACE_ASSERT (rep != 0);
-  ACE_ASSERT (new_rep != 0);
+  ACE_ASSERT (rep != nullptr);
+  ACE_ASSERT (new_rep != nullptr);
   // Use value_ready_mutex_ for both condition and ref count management
   ACE_GUARD (ACE_SYNCH_RECURSIVE_MUTEX, r_mon, rep->value_ready_mutex_);
 
@@ -143,9 +123,7 @@ ACE_Future_Rep<T>::assign (ACE_Future_Re
 
 template <class T>
 ACE_Future_Rep<T>::ACE_Future_Rep ()
-  : value_ (0),
-    ref_count_ (0),
-    value_ready_ (value_ready_mutex_)
+  : value_ready_ (value_ready_mutex_)
 {
 }
 
@@ -158,7 +136,7 @@ ACE_Future_Rep<T>::~ACE_Future_Rep ()
 template <class T> int
 ACE_Future_Rep<T>::ready () const
 {
-  return this->value_ != 0;
+  return this->value_ != nullptr;
 }
 
 template <class T> int
@@ -166,7 +144,7 @@ ACE_Future_Rep<T>::set (const T &r,
                         ACE_Future<T> &caller)
 {
   // If the value is already produced, ignore it...
-  if (this->value_ == 0)
+  if (this->value_ == nullptr)
     {
       ACE_GUARD_RETURN (ACE_SYNCH_RECURSIVE_MUTEX,
                         ace_mon,
@@ -175,18 +153,15 @@ ACE_Future_Rep<T>::set (const T &r,
       // Otherwise, create a new result value.  Note the use of the
       // Double-checked locking pattern to avoid multiple allocations.
 
-      if (this->value_ == 0)       // Still no value, so proceed
+      if (this->value_ == nullptr)       // Still no value, so proceed
         {
           ACE_NEW_RETURN (this->value_,
                           T (r),
                           -1);
 
           // Remove and notify all subscribed observers.
-          typename OBSERVER_COLLECTION::iterator iterator =
-            this->observer_collection_.begin ();
-
-          typename OBSERVER_COLLECTION::iterator end =
-            this->observer_collection_.end ();
+          typename OBSERVER_COLLECTION::iterator iterator = this->observer_collection_.begin ();
+          typename OBSERVER_COLLECTION::iterator end = this->observer_collection_.end ();
 
           while (iterator != end)
             {
@@ -210,7 +185,7 @@ ACE_Future_Rep<T>::get (T &value,
                         ACE_Time_Value *tv) const
 {
   // If the value is already produced, return it.
-  if (this->value_ == 0)
+  if (this->value_ == nullptr)
     {
       ACE_GUARD_RETURN (ACE_SYNCH_RECURSIVE_MUTEX, ace_mon,
                         this->value_ready_mutex_,
@@ -218,7 +193,7 @@ ACE_Future_Rep<T>::get (T &value,
       // If the value is not yet defined we must block until the
       // producer writes to it.
 
-      while (this->value_ == 0)
+      while (this->value_ == nullptr)
         // Perform a timed wait.
         if (this->value_ready_.wait (tv) == -1)
           return -1;
@@ -242,10 +217,10 @@ ACE_Future_Rep<T>::attach (ACE_Future_Ob
   int result = 1;
 
   // If the value is already produced, then notify observer
-  if (this->value_ == 0)
+  if (this->value_ == nullptr)
     result = this->observer_collection_.insert (observer);
   else
-      observer->update (caller);
+    observer->update (caller);
 
   return result;
 }
@@ -264,7 +239,7 @@ template <class T>
 ACE_Future_Rep<T>::operator T ()
 {
   // If the value is already produced, return it.
-  if (this->value_ == 0)
+  if (this->value_ == nullptr)
     {
       // Constructor of ace_mon acquires the mutex.
       ACE_GUARD_RETURN (ACE_SYNCH_RECURSIVE_MUTEX, ace_mon, this->value_ready_mutex_, 0);
@@ -274,7 +249,7 @@ ACE_Future_Rep<T>::operator T ()
 
       // Wait ``forever.''
 
-      while (this->value_ == 0)
+      while (this->value_ == nullptr)
         if (this->value_ready_.wait () == -1)
           // What to do in this case since we've got to indicate
           // failure somehow?  Exceptions would be nice, but they're
@@ -356,8 +331,7 @@ ACE_Future<T>::ready () const
 }
 
 template <class T> int
-ACE_Future<T>::get (T &value,
-                    ACE_Time_Value *tv) const
+ACE_Future<T>::get (T &value, ACE_Time_Value *tv) const
 {
   // We return the ACE_Future_rep.
   return this->future_rep_->get (value, tv);
diff -pruN 7.1.2+dfsg-2/ace/Future.h 7.1.3+dfsg-1/ace/Future.h
--- 7.1.2+dfsg-2/ace/Future.h	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Future.h	2024-01-16 10:27:08.000000000 +0000
@@ -16,6 +16,7 @@
 
 #include /**/ "ace/pre.h"
 
+#include <atomic>
 #include "ace/Unbounded_Set.h"
 #include "ace/Strategies_T.h"
 
@@ -47,15 +48,13 @@ class ACE_Future_Holder
 {
 public:
   ACE_Future_Holder (const ACE_Future<T> &future);
-  ~ACE_Future_Holder ();
+  ~ACE_Future_Holder () = default;
+  ACE_Future_Holder () = delete;
 
   /// Declare the dynamic allocation hooks.
   ACE_ALLOC_HOOK_DECLARE;
 
   ACE_Future<T> item_;
-
-protected:
-  ACE_Future_Holder ();
 };
 
 /**
@@ -73,7 +72,7 @@ class ACE_Future_Observer
 {
 public:
   /// Destructor
-  virtual ~ACE_Future_Observer ();
+  virtual ~ACE_Future_Observer () = default;
 
   /// Called by the ACE_Future in which we are subscribed to when
   /// its value is written to.
@@ -84,7 +83,7 @@ public:
 
 protected:
   /// Constructor
-  ACE_Future_Observer ();
+  ACE_Future_Observer () = default;
 };
 
 /**
@@ -197,10 +196,10 @@ private:
   int ready () const;
 
   /// Pointer to the result.
-  T *value_;
+  std::atomic<T*> value_ {};
 
   /// Reference count.
-  int ref_count_;
+  int ref_count_ {};
 
   typedef ACE_Future_Observer<T> OBSERVER;
 
diff -pruN 7.1.2+dfsg-2/ace/Future_Set.cpp 7.1.3+dfsg-1/ace/Future_Set.cpp
--- 7.1.2+dfsg-2/ace/Future_Set.cpp	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Future_Set.cpp	2024-01-16 10:27:08.000000000 +0000
@@ -59,14 +59,13 @@ ACE_Future_Set<T>::is_empty () const
 template <class T> int
 ACE_Future_Set<T>::insert (ACE_Future<T> &future)
 {
-  FUTURE_HOLDER *future_holder;
+  FUTURE_HOLDER *future_holder {};
   ACE_NEW_RETURN (future_holder,
                   FUTURE_HOLDER (future),
                   -1);
 
   FUTURE_REP *future_rep = future.get_rep ();
-  int result = this->future_map_.bind (future_rep,
-                                       future_holder);
+  int const result = this->future_map_.bind (future_rep, future_holder);
 
   // If a new map entry was created, then attach to the future,
   // otherwise we were already attached to the future or some error
@@ -83,7 +82,7 @@ ACE_Future_Set<T>::insert (ACE_Future<T>
 template <class T> void
 ACE_Future_Set<T>::update (const ACE_Future<T> &future)
 {
-  ACE_Message_Block *mb = 0;
+  ACE_Message_Block *mb = nullptr;
   FUTURE &local_future = const_cast<ACE_Future<T> &> (future);
 
   ACE_NEW (mb,
@@ -100,12 +99,11 @@ ACE_Future_Set<T>::next_readable (ACE_Fu
   if (this->is_empty ())
     return 0;
 
-  ACE_Message_Block *mb = 0;
-  FUTURE_REP *future_rep = 0;
+  ACE_Message_Block *mb = nullptr;
+  FUTURE_REP *future_rep = nullptr;
 
   // Wait for a "readable future" signal from the message queue.
-  if (this->future_notification_queue_->dequeue_head (mb,
-                                                      tv) != -1)
+  if (this->future_notification_queue_->dequeue_head (mb, tv) != -1)
     {
       // Extract future rep from the message block.
       future_rep = reinterpret_cast<FUTURE_REP *> (mb->base ());
@@ -117,9 +115,8 @@ ACE_Future_Set<T>::next_readable (ACE_Fu
     return 0;
 
   // Remove the hash map entry with the specified future rep from our map.
-  FUTURE_HOLDER *future_holder = 0;
-  if (this->future_map_.find (future_rep,
-                              future_holder) != -1)
+  FUTURE_HOLDER *future_holder = nullptr;
+  if (this->future_map_.find (future_rep, future_holder) != -1)
     {
       future = future_holder->item_;
       this->future_map_.unbind (future_rep);
diff -pruN 7.1.2+dfsg-2/ace/SOCK_Dgram.cpp 7.1.3+dfsg-1/ace/SOCK_Dgram.cpp
--- 7.1.2+dfsg-2/ace/SOCK_Dgram.cpp	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/SOCK_Dgram.cpp	2024-01-16 10:27:08.000000000 +0000
@@ -311,12 +311,12 @@ ACE_SOCK_Dgram::recv (iovec iov[],
 #define ACE_USE_MSG_CONTROL
   union control_buffer {
     cmsghdr control_msg_header;
-#if defined (IP_RECVDSTADDR)
+#if defined (IP_RECVDSTADDR) && !defined (ACE_HAS_NONCONST_CMSG_SPACE)
     u_char padding[ACE_CMSG_SPACE (sizeof (in_addr))];
-#elif defined (IP_PKTINFO)
+#elif defined (IP_PKTINFO) && !defined (ACE_HAS_NONCONST_CMSG_SPACE)
     u_char padding[ACE_CMSG_SPACE (sizeof (in_pktinfo))];
 #endif
-#if defined (ACE_HAS_IPV6)
+#if defined (ACE_HAS_IPV6) && !defined (ACE_HAS_NONCONST_CMSG_SPACE)
     u_char padding6[ACE_CMSG_SPACE (sizeof (in6_pktinfo))];
 #endif
   } cbuf;
@@ -349,7 +349,7 @@ ACE_SOCK_Dgram::recv (iovec iov[],
   if (to_addr) {
     this->get_local_addr (*to_addr);
     if (to_addr->get_type() == AF_INET) {
-#if defined (IP_RECVDSTADDR) || defined (IP_PKTINFO)
+#if (defined (IP_RECVDSTADDR) || defined (IP_PKTINFO)) && !defined (ACE_HAS_NONCONST_CMSG_SPACE)
       for (cmsghdr *ptr = ACE_CMSG_FIRSTHDR (&recv_msg); ptr; ptr = ACE_CMSG_NXTHDR (&recv_msg, ptr)) {
 #if defined (IP_RECVDSTADDR)
         if (ptr->cmsg_level == IPPROTO_IP && ptr->cmsg_type == IP_RECVDSTADDR) {
@@ -369,7 +369,7 @@ ACE_SOCK_Dgram::recv (iovec iov[],
       }
 #endif
     }
-#if defined (ACE_HAS_IPV6) && defined (IPV6_PKTINFO)
+#if defined (ACE_HAS_IPV6) && defined (IPV6_PKTINFO) && !defined (ACE_HAS_NONCONST_CMSG_SPACE)
     else if (to_addr->get_type() == AF_INET6) {
       for (cmsghdr *ptr = ACE_CMSG_FIRSTHDR (&recv_msg); ptr; ptr = ACE_CMSG_NXTHDR (&recv_msg, ptr)) {
         if (ptr->cmsg_level == IPPROTO_IPV6 && ptr->cmsg_type == IPV6_PKTINFO) {
diff -pruN 7.1.2+dfsg-2/ace/Version.h 7.1.3+dfsg-1/ace/Version.h
--- 7.1.2+dfsg-2/ace/Version.h	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/Version.h	2024-01-16 10:27:08.000000000 +0000
@@ -4,7 +4,7 @@
 
 #define ACE_MAJOR_VERSION 7
 #define ACE_MINOR_VERSION 1
-#define ACE_MICRO_VERSION 2
-#define ACE_VERSION "7.1.2"
-#define ACE_VERSION_CODE 0x70102
+#define ACE_MICRO_VERSION 3
+#define ACE_VERSION "7.1.3"
+#define ACE_VERSION_CODE 0x70103
 #define ACE_MAKE_VERSION_CODE(a,b,c) (((a) << 16) + ((b) << 8) + (c))
diff -pruN 7.1.2+dfsg-2/ace/config-freebsd.h 7.1.3+dfsg-1/ace/config-freebsd.h
--- 7.1.2+dfsg-2/ace/config-freebsd.h	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/config-freebsd.h	2024-01-16 10:27:08.000000000 +0000
@@ -43,7 +43,6 @@
 #define ACE_HAS_POSIX_TIME
 #define ACE_HAS_RECURSIVE_THR_EXIT_SEMANTICS
 #define ACE_HAS_RTLD_LAZY_V
-#define ACE_HAS_SEMUN
 #define ACE_HAS_SIGISMEMBER_BUG
 #define ACE_HAS_SIGSUSPEND
 #define ACE_HAS_SIGWAIT
@@ -182,6 +181,14 @@ enum schedparam_policy {
 # define ACE_HAS_VOID_UNSETENV
 #endif
 
+#if (__FreeBSD_version >= 800025)
+# define ACE_HAS_CPUSET_T
+#endif
+
+#if (__FreeBSD_version < 1200059)
+# define ACE_HAS_SEMUN
+#endif
+
 #include /**/ "ace/post.h"
 
 #endif /* ACE_CONFIG_H */
diff -pruN 7.1.2+dfsg-2/ace/config-qnx.h 7.1.3+dfsg-1/ace/config-qnx.h
--- 7.1.2+dfsg-2/ace/config-qnx.h	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/ace/config-qnx.h	2024-01-16 10:27:08.000000000 +0000
@@ -138,6 +138,8 @@
 # define ACE_SIZEOF_DOUBLE   8
 # define ACE_SIZEOF_FLOAT    4
 # define _POSIX_C_SOURCE 199506
+#else
+# define ACE_HAS_NONCONST_CMSG_SPACE
 #endif
 
 #define ACE_LACKS_ISCTYPE
diff -pruN 7.1.2+dfsg-2/bin/copy-local-script.sh 7.1.3+dfsg-1/bin/copy-local-script.sh
--- 7.1.2+dfsg-2/bin/copy-local-script.sh	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/bin/copy-local-script.sh	2024-01-16 10:27:08.000000000 +0000
@@ -1,7 +1,7 @@
 #!/bin/sh
 
 for i in *.gz *.bz2 *.zip *.md5; do
-  d=`echo $i | sed 's/\.[tz][ai][rp]/-7.1.2&/'`
+  d=`echo $i | sed 's/\.[tz][ai][rp]/-7.1.3&/'`
   echo "Copying $i to $d"
   cp -ip $i $d
 done
diff -pruN 7.1.2+dfsg-2/bin/diff-builds-and-group-fixed-tests-only.sh 7.1.3+dfsg-1/bin/diff-builds-and-group-fixed-tests-only.sh
--- 7.1.2+dfsg-2/bin/diff-builds-and-group-fixed-tests-only.sh	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/bin/diff-builds-and-group-fixed-tests-only.sh	2024-01-16 10:27:08.000000000 +0000
@@ -2,7 +2,7 @@
 
 if test -z $1; then newdate=`date -u +%Y_%m_%d`; else newdate=$1; fi
 if test -z $2; then prefix=`date -u +%Y%m%d%a`; else prefix=$2; fi
-if test -z $3; then olddate=2023_06_28; else olddate=$3; fi
+if test -z $3; then olddate=2023_10_30; else olddate=$3; fi
 if test -z $ACE_ROOT; then ACE_ROOT=..; fi
 if test -z $TAO_ROOT; then TAO_ROOT=${ACE_ROOT}/TAO; fi
 #
diff -pruN 7.1.2+dfsg-2/bin/install_proj.mk 7.1.3+dfsg-1/bin/install_proj.mk
--- 7.1.2+dfsg-2/bin/install_proj.mk	1970-01-01 00:00:00.000000000 +0000
+++ 7.1.3+dfsg-1/bin/install_proj.mk	2024-01-16 10:27:08.000000000 +0000
@@ -0,0 +1,15 @@
+include $(PROJECT_MAKEFILE)
+
+POTENTIAL_FILES = $(BIN_UNCHECKED) $(SHLIB_UNCHECKED) $(LIB_UNCHECKED)
+ACTUAL_FILES := $(wildcard $(POTENTIAL_FILES))
+
+.PHONY: checked-install
+ifeq ($(ACTUAL_FILES),)
+checked-install:
+	@echo Skipping $(PROJECT_MAKEFILE:GNUmakefile.%=%), not built
+else
+.PHONY: checked-install-message
+checked-install-message:
+	@echo Installing $(ACTUAL_FILES)
+checked-install: checked-install-message install
+endif
diff -pruN 7.1.2+dfsg-2/bin/install_proj.sh 7.1.3+dfsg-1/bin/install_proj.sh
--- 7.1.2+dfsg-2/bin/install_proj.sh	1970-01-01 00:00:00.000000000 +0000
+++ 7.1.3+dfsg-1/bin/install_proj.sh	2024-01-16 10:27:08.000000000 +0000
@@ -0,0 +1,13 @@
+#!/bin/sh
+
+# ACE's "make install" for an MPC-generated workspace will build all targets that aren't yet built
+# This script looks for projects that have been built and installs just those projects
+this_dir=$(realpath $(dirname $0))
+for makefile in $(find . -type f -name 'GNUmakefile.*'); do
+    if grep -q 'GNU Makefile' $makefile; then
+        echo Checking $makefile
+        cd $(dirname $makefile)
+        make -f $this_dir/install_proj.mk PROJECT_MAKEFILE=$(basename $makefile) checked-install "$@"
+        cd - >/dev/null
+    fi
+done
diff -pruN 7.1.2+dfsg-2/debian/changelog 7.1.3+dfsg-1/debian/changelog
--- 7.1.2+dfsg-2/debian/changelog	2023-12-06 17:28:25.000000000 +0000
+++ 7.1.3+dfsg-1/debian/changelog	2024-01-22 11:28:32.000000000 +0000
@@ -1,3 +1,11 @@
+ace (7.1.3+dfsg-1) experimental; urgency=medium
+
+  * Team upload.
+  * Update to upstream v7.1.3
+    - Sync debian/* with upstream.
+
+ -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 22 Jan 2024 11:28:32 +0000
+
 ace (7.1.2+dfsg-2) unstable; urgency=medium
 
   * Team upload.
diff -pruN 7.1.2+dfsg-2/debian/control 7.1.3+dfsg-1/debian/control
--- 7.1.2+dfsg-2/debian/control	2023-12-01 20:50:21.000000000 +0000
+++ 7.1.3+dfsg-1/debian/control	2024-01-22 11:27:26.000000000 +0000
@@ -27,7 +27,7 @@ Description: makefile, project, and work
   * mpc-ace: generates project files for a single target
   * mwc-ace: generates workspace files for a set of projects
 
-Package: libace-7.1.2
+Package: libace-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -45,7 +45,7 @@ Description: C++ network programming fra
 Package: libace-dev
 Architecture: any
 Section: libdevel
-Depends: libace-7.1.2 (= ${binary:Version}), ${misc:Depends}
+Depends: libace-7.1.3 (= ${binary:Version}), ${misc:Depends}
 Suggests: libace-doc, pkg-config
 Replaces: mpc-ace (<< 5.6.3-4)
 Description: C++ network programming framework - development files
@@ -62,7 +62,7 @@ Description: C++ network programming fra
  This package contains the ACE overview documentation, tutorials,
  examples, and information regarding upstream development.
 
-Package: libace-ssl-7.1.2
+Package: libace-ssl-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -73,12 +73,12 @@ Description: ACE secure socket layer lib
 Package: libace-ssl-dev
 Architecture: any
 Section: libdevel
-Depends: libace-ssl-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), libssl-dev, ${misc:Depends}
+Depends: libace-ssl-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), libssl-dev, ${misc:Depends}
 Description: ACE secure socket layer library - development files
  This package contains the header files and static library for the ACE
  SSL library.
 
-Package: libace-rmcast-7.1.2
+Package: libace-rmcast-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -92,12 +92,12 @@ Description: ACE reliable multicast libr
 Package: libace-rmcast-dev
 Architecture: any
 Section: libdevel
-Depends: libace-rmcast-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libace-rmcast-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE reliable multicast library - development files
  This package contains the header files and static library for the ACE
  reliable multicast library.
 
-Package: libace-tmcast-7.1.2
+Package: libace-tmcast-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -111,12 +111,12 @@ Description: ACE transactional multicast
 Package: libace-tmcast-dev
 Architecture: any
 Section: libdevel
-Depends: libace-tmcast-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libace-tmcast-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE transactional multicast library - development files
  This package contains the header files and static library for the ACE
  transactional multicast library.
 
-Package: libace-htbp-7.1.2
+Package: libace-htbp-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -130,12 +130,12 @@ Description: ACE protocol over HTTP tunn
 Package: libace-htbp-dev
 Architecture: any
 Section: libdevel
-Depends: libace-htbp-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libace-htbp-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE protocol over HTTP tunneling library - development files
  This package contains the header files and static library for the ACE
  HTBP library.
 
-Package: libace-inet-7.1.2
+Package: libace-inet-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -146,15 +146,15 @@ Description: ACE Inet protocol library
 Package: libace-inet-dev
 Architecture: any
 Section: libdevel
-Depends: libace-inet-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libace-inet-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE Inet protocol library - development files
  This package contains the header files and static library for the ACE
  Inet protocol library.
 
-Package: libace-inet-ssl-7.1.2
+Package: libace-inet-ssl-7.1.3
 Architecture: any
 Section: libs
-Depends: libace-inet-7.1.2, libace-ssl-7.1.2, ${shlibs:Depends}, ${misc:Depends}
+Depends: libace-inet-7.1.3, libace-ssl-7.1.3, ${shlibs:Depends}, ${misc:Depends}
 Description: ACE SSL-enabled Inet protocol library
  This package provides an ACE addon library for clients (and possibly
  servers at some point) using Inet protocols which support SSL, such as
@@ -163,7 +163,7 @@ Description: ACE SSL-enabled Inet protoc
 Package: libace-inet-ssl-dev
 Architecture: any
 Section: libdevel
-Depends: libace-inet-ssl-7.1.2 (= ${binary:Version}), libace-inet-dev (= ${binary:Version}), libace-ssl-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libace-inet-ssl-7.1.3 (= ${binary:Version}), libace-inet-dev (= ${binary:Version}), libace-ssl-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE SSL-enabled Inet protocol library - development files
  This package contains the header files and static library for the ACE
  SSL-enabled Inet protocol library.
@@ -180,7 +180,7 @@ Description: ACE perfect hash function g
  basically the same options and functionality. ace_gperf simply takes
  advantage of some of the features provided by the ACE library.
 
-Package: libacexml-7.1.2
+Package: libacexml-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -196,12 +196,12 @@ Package: libacexml-dev
 Architecture: any
 Section: libdevel
 Replaces: libace-dev (<< 5.7.7-4)
-Depends: libacexml-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libacexml-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE SAX based XML parsing library - development files
  This package contains the header files and static library for the ACE
  XML parsing library.
 
-Package: libace-xml-utils-7.1.2
+Package: libace-xml-utils-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -215,12 +215,12 @@ Package: libace-xml-utils-dev
 Architecture: any
 Section: libdevel
 Replaces: libace-dev (<< 5.7.7-4)
-Depends: libace-xml-utils-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}, libxerces-c-dev
+Depends: libace-xml-utils-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}, libxerces-c-dev
 Description: ACE XML utility classes and methods - development files
  This package contains the header files and static library for the ACE XML
  Utils library
 
-Package: libkokyu-7.1.2
+Package: libkokyu-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -234,12 +234,12 @@ Description: ACE scheduling and dispatch
 Package: libkokyu-dev
 Architecture: any
 Section: libdevel
-Depends: libkokyu-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libkokyu-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE scheduling and dispatching library - development files
  This package contains the header files and static library for the ACE
  scheduling and dispatching library.
 
-Package: libace-xtreactor-7.1.2
+Package: libace-xtreactor-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -257,12 +257,12 @@ Description: ACE-GUI reactor integration
 Package: libace-xtreactor-dev
 Architecture: any
 Section: libdevel
-Depends: libace-xtreactor-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), libxt-dev (>= 4.3.0), ${misc:Depends}
+Depends: libace-xtreactor-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), libxt-dev (>= 4.3.0), ${misc:Depends}
 Description: ACE-GUI reactor integration for Xt - development files
  This package contains header files and static library for the ACE-Xt
  reactor integration.
 
-Package: libace-tkreactor-7.1.2
+Package: libace-tkreactor-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -281,12 +281,12 @@ Description: ACE-GUI reactor integration
 Package: libace-tkreactor-dev
 Architecture: any
 Section: libdevel
-Depends: libace-tkreactor-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), tk-dev (>= 8.5), ${misc:Depends}
+Depends: libace-tkreactor-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), tk-dev (>= 8.5), ${misc:Depends}
 Description: ACE-GUI reactor integration for Tk - development files
  This package contains header files and static library for the ACE-Tk
  reactor integration.
 
-Package: libace-flreactor-7.1.2
+Package: libace-flreactor-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -304,12 +304,12 @@ Description: ACE-GUI reactor integration
 Package: libace-flreactor-dev
 Architecture: any
 Section: libdevel
-Depends: libace-flreactor-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), libfltk1.3-dev, ${misc:Depends}
+Depends: libace-flreactor-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), libfltk1.3-dev, ${misc:Depends}
 Description: ACE-GUI reactor integration for FLTK - development files
  This package contains header files and static library for the ACE-FLTK
  reactor integration.
 
-Package: libace-foxreactor-7.1.2
+Package: libace-foxreactor-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -326,7 +326,7 @@ Description: ACE-GUI reactor integration
 Package: libace-foxreactor-dev
 Architecture: any
 Section: libdevel
-Depends: libace-foxreactor-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), libfox-1.6-dev, ${misc:Depends}
+Depends: libace-foxreactor-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), libfox-1.6-dev, ${misc:Depends}
 Description: ACE-GUI reactor integration for FOX - development files
  This package contains header files and static library for the ACE-FOX
  reactor integration.
@@ -343,7 +343,7 @@ Description: ACE network service impleme
  files to link the various ACE network services together, either
  statically or dynamically, and form complete server programs.
 
-Package: libnetsvcs-7.1.2
+Package: libnetsvcs-7.1.3
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -357,7 +357,7 @@ Description: ACE network service impleme
 Package: libnetsvcs-dev
 Architecture: any
 Section: libdevel
-Depends: libnetsvcs-7.1.2 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
+Depends: libnetsvcs-7.1.3 (= ${binary:Version}), libace-dev (= ${binary:Version}), ${misc:Depends}
 Description: ACE network service implementations - development files
  ACE network services provide reusable components for common
  distributed system tasks such as logging, naming, locking, and time
diff -pruN 7.1.2+dfsg-2/docs/Download.html 7.1.3+dfsg-1/docs/Download.html
--- 7.1.2+dfsg-2/docs/Download.html	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/docs/Download.html	2024-01-16 10:27:08.000000000 +0000
@@ -90,81 +90,81 @@ Windows line feeds. For all other platfo
 </P>
 
 <UL>
-<LI> <B>Latest ACE+TAO Micro Release.</B> The latest micro release is ACE 7.1.1 and TAO 3.1.1
-(ACE+TAO x.1.1), please use the links below to download it.<P>
+<LI> <B>Latest ACE+TAO Micro Release.</B> The latest micro release is ACE 7.1.2 and TAO 3.1.2
+(ACE+TAO x.1.2), please use the links below to download it.<P>
 
 <TABLE BORDER="4">
   <TR><TH>Filename</TH><TH>Description</TH><TH>Full</TH><TH>Sources only</TH></TR>
   <TR><TD>ACE+TAO.tar.gz</TD>
       <TD>ACE+TAO (tar+gzip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-7.1.1.tar.gz">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.1.tar.gz">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-7.1.2.tar.gz">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.2.tar.gz">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-src-7.1.1.tar.gz">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.1.tar.gz">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-src-7.1.2.tar.gz">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.2.tar.gz">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE+TAO.tar.bz2</TD>
       <TD>ACE+TAO (tar+bzip2 format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-7.1.1.tar.bz2">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.1.tar.bz2">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-7.1.2.tar.bz2">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.2.tar.bz2">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-src-7.1.1.tar.bz2">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.1.tar.bz2">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-src-7.1.2.tar.bz2">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.2.tar.bz2">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE+TAO.zip</TD>
       <TD>ACE+TAO (zip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-7.1.1.zip">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.1.zip">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-7.1.2.zip">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-7.1.2.zip">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE+TAO-src-7.1.1.zip">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.1.zip">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE+TAO-src-7.1.2.zip">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE+TAO-src-7.1.2.zip">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE-html.tar.gz</TD>
       <TD>Doxygen documentation for ACE+TAO (tar+gzip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-html-7.1.1.tar.gz">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.1.tar.gz">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-html-7.1.2.tar.gz">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.2.tar.gz">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE-html.tar.bz2</TD>
       <TD>Doxygen documentation for ACE+TAO (tar+bzip2 format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-html-7.1.1.tar.bz2">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.1.tar.bz2">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-html-7.1.2.tar.bz2">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.2.tar.bz2">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE-html.zip</TD>
       <TD>Doxygen documentation for ACE+TAO (zip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-html-7.1.1.zip">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.1.zip">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-html-7.1.2.zip">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-html-7.1.2.zip">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE.tar.gz</TD>
       <TD>ACE only (tar+gzip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-7.1.1.tar.gz">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.1.tar.gz">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-7.1.2.tar.gz">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.2.tar.gz">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-src-7.1.1.tar.gz">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.1.tar.gz">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-src-7.1.2.tar.gz">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.2.tar.gz">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE.tar.bz2</TD>
       <TD>ACE only (tar+bzip2 format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-7.1.1.tar.bz2">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.1.tar.bz2">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-7.1.2.tar.bz2">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.2.tar.bz2">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-src-7.1.1.tar.bz2">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.1.tar.bz2">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-src-7.1.2.tar.bz2">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.2.tar.bz2">FTP</A>]
       </TD>
   </TR>
   <TR><TD>ACE.zip</TD>
       <TD>ACE only (zip format)</TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-7.1.1.zip">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.1.zip">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-7.1.2.zip">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-7.1.2.zip">FTP</A>]
       </TD>
-      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_1/ACE-src-7.1.1.zip">HTTP</A>]
-          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.1.zip">FTP</A>]
+      <TD>[<A HREF="https://github.com/DOCGroup/ACE_TAO/releases/download/ACE%2BTAO-7_1_2/ACE-src-7.1.2.zip">HTTP</A>]
+          [<A HREF="ftp://download.dre.vanderbilt.edu/previous_versions/ACE-src-7.1.2.zip">FTP</A>]
       </TD>
   </TR>
 </TABLE>
diff -pruN 7.1.2+dfsg-2/etc/index.html 7.1.3+dfsg-1/etc/index.html
--- 7.1.2+dfsg-2/etc/index.html	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/etc/index.html	2024-01-16 10:27:08.000000000 +0000
@@ -30,6 +30,7 @@
     <hr>
     We do have the documentation for previous releases
     <ul>
+      <LI><P><A HREF="7.1.2/html">7.1.2</A></P></LI>
       <LI><P><A HREF="7.1.1/html">7.1.1</A></P></LI>
       <LI><P><A HREF="7.1.0/html">7.1.0</A></P></LI>
       <LI><P><A HREF="7.0.11/html">7.0.11</A></P></LI>
diff -pruN 7.1.2+dfsg-2/tests/Future_Stress_Test.cpp 7.1.3+dfsg-1/tests/Future_Stress_Test.cpp
--- 7.1.2+dfsg-2/tests/Future_Stress_Test.cpp	1970-01-01 00:00:00.000000000 +0000
+++ 7.1.3+dfsg-1/tests/Future_Stress_Test.cpp	2024-01-16 10:27:08.000000000 +0000
@@ -0,0 +1,148 @@
+
+//=============================================================================
+/**
+ *  @file    Future_Stress_Test.cpp
+ *
+ *  This example tests the ACE Future set() and get() operations in
+ *  multithreaded environment and concurrent access.
+ *
+ *  Usage: Future_Stress_Test [-t <duration in seconds>]
+ *            [-n <number of threads>]
+ *
+ *  @see https://github.com/DOCGroup/ACE_TAO/issues/2163
+ *
+ *  @author Andres Kruse <Frank.Hilliger@cs-sol.de>
+ */
+//=============================================================================
+
+#include "test_config.h"
+#include <ace/Time_Value.h>
+#include <ace/Countdown_Time.h>
+#include <ace/Future.h>
+#include <ace/Get_Opt.h>
+
+#include <random>
+
+
+#if defined (ACE_HAS_THREADS)
+
+struct Worker_Config
+{
+  int a;
+  int b;
+  int c;
+  ACE_Future<int> result;
+};
+
+void* worker (void* args)
+{
+  Worker_Config* config = static_cast<Worker_Config*>(args);
+  int r = config->a + config->b * config->c;
+  config->result.set(r);
+
+  return 0;
+}
+
+void* runner (void* args)
+{
+  ACE_DEBUG ((LM_DEBUG, ACE_TEXT ("(%t) runner start\n")));
+
+  std::random_device              rd;
+  std::mt19937                    gen(rd());
+  std::uniform_int_distribution<> dis(1,1000000);
+  ACE_Time_Value* duration = static_cast<ACE_Time_Value*>(args);
+  ACE_Countdown_Time timer(duration);
+  timer.start();
+  uint64_t runNum = 0;
+  do
+  {
+    if( ++runNum % 5000 == 0 )
+    {
+      ACE_DEBUG ((LM_DEBUG, ACE_TEXT ("(%t) runner iteration %u\n"), runNum));
+    }
+    ACE_Future<int> result;
+    Worker_Config config;
+    config.a = dis(gen);
+    config.b = dis(gen);
+    config.c = dis(gen);
+    config.result = result;
+    ACE_hthread_t thread_id;
+    int expected_res = config.a+config.b*config.c;
+    int actual_res = -1;
+    if (ACE_Thread::spawn((ACE_THR_FUNC)worker,
+                        static_cast<void*>(&config), THR_NEW_LWP | THR_JOINABLE, 0,
+                        &thread_id) == -1)
+    {
+        ACE_ERROR ((LM_INFO,
+              ACE_TEXT ("worker thread spawn failed\n")));
+    }
+    result.get(actual_res);
+    if( actual_res != expected_res )
+    {
+      // hit the bug...
+      ACE_ERROR ((LM_INFO,
+          ACE_TEXT ("unexpected ACE_Future result\n")));
+      abort();
+    }
+    ACE_THR_FUNC_RETURN status;
+    ACE_Thread::join(thread_id, &status);
+    timer.update();
+  } while( *duration != ACE_Time_Value::zero );
+   ACE_DEBUG ((LM_DEBUG, ACE_TEXT ("(%t) runner done\n"), runNum));
+
+   return 0;
+}
+
+int
+run_main (int argc, ACE_TCHAR *argv[])
+{
+  ACE_START_TEST (ACE_TEXT ("Future_Stress_Test"));
+
+  ACE_Time_Value duration(5);
+  long n_threads = 5;
+
+  ACE_Get_Opt getopt (argc, argv, ACE_TEXT ("t:n:"));
+  bool valid = true;
+  int c;
+  while ((c = getopt ()) != -1 && valid)
+  {
+  //FUZZ: enable check_for_lack_ACE_OS
+    switch (c)
+    {
+      case 't':
+        duration.set(ACE_OS::atoi (getopt.opt_arg ()));
+        break;
+      case 'n':
+        n_threads = ACE_OS::atoi (getopt.opt_arg ());
+        break;
+      default:
+        ACE_ERROR ((LM_ERROR,
+                    "Usage: Future_Stress_Test [-t <duration in seconds>]"
+                    "\t[-n <number of threads>]\n"));
+        valid = false;
+        break;
+    }
+  }
+
+  if (valid)
+  {
+    ACE_Thread_Manager::instance ()->spawn_n (n_threads,
+      ACE_THR_FUNC (runner),
+      static_cast<void*>(&duration),
+      THR_NEW_LWP | THR_DETACHED);
+
+    ACE_Thread_Manager::instance ()->wait ();
+    ACE_DEBUG ((LM_DEBUG, ACE_TEXT ("(%t) All threads finished, cleanup and exit\n")));
+  }
+  ACE_END_TEST;
+  return 0;
+}
+
+#else
+int
+run_main (int, ACE_TCHAR *[])
+{
+  ACE_ERROR ((LM_INFO,
+              ACE_TEXT ("threads not supported on this platform\n")));
+}
+#endif /* ACE_HAS_THREADS */
diff -pruN 7.1.2+dfsg-2/tests/run_test.lst 7.1.3+dfsg-1/tests/run_test.lst
--- 7.1.2+dfsg-2/tests/run_test.lst	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/tests/run_test.lst	2024-01-16 10:27:08.000000000 +0000
@@ -127,6 +127,7 @@ FIFO_Test: !ACE_FOR_TAO
 Framework_Component_Test: !STATIC !nsk
 Future_Set_Test: !nsk !ACE_FOR_TAO
 Future_Test: !nsk !ACE_FOR_TAO
+Future_Stress_Test: !nsk !ACE_FOR_TAO
 Get_Opt_Test
 Handle_Set_Test: !ACE_FOR_TAO
 Hash_Map_Bucket_Iterator_Test
diff -pruN 7.1.2+dfsg-2/tests/tests.mpc 7.1.3+dfsg-1/tests/tests.mpc
--- 7.1.2+dfsg-2/tests/tests.mpc	2023-10-30 06:58:03.000000000 +0000
+++ 7.1.3+dfsg-1/tests/tests.mpc	2024-01-16 10:27:08.000000000 +0000
@@ -960,6 +960,14 @@ project(Future Set Test) : acetest {
   }
 }
 
+project(Future Stress Test) : acetest {
+  avoids += ace_for_tao
+  exename = Future_Stress_Test
+  Source_Files {
+    Future_Stress_Test.cpp
+  }
+}
+
 project(Get Opt Test) : acetest {
   exename = Get_Opt_Test
   Source_Files {
